AWSTemplateFormatVersion: 2010-09-09
#Not working yet
Resources:
  DemoVPC:
    Type: AWS::EC2::VPC
    Properties:
      CidrBlock: 10.0.0.0/16
      InstanceTenancy: default
      EnableDnsSupport: 'true'
      EnableDnsHostnames: 'true'

  PrivateSubnetA:
    Type: AWS::EC2::Subnet
    Properties:
      CidrBlock: 10.0.2.0/24
      AvailabilityZone: eu-west-3a
      VpcId: !Ref 'DemoVPC'

  PrivateSubnetB:
    Type: AWS::EC2::Subnet
    Properties:
      CidrBlock: 10.0.3.0/24
      AvailabilityZone: eu-west-3b
      VpcId: !Ref 'DemoVPC'

  PrivateSubnetC:
    Type: AWS::EC2::Subnet
    Properties:
      CidrBlock: 10.0.4.0/24
      AvailabilityZone: eu-west-3c
      VpcId: !Ref 'DemoVPC'

  InternetGateway:
    Type: AWS::EC2::InternetGateway

  NetworkACL:
    Type: AWS::EC2::NetworkAcl
    Properties:
      VpcId: !Ref 'DemoVPC'

  NetworkACLEntry1:
    Type: AWS::EC2::NetworkAclEntry
    Properties:
      CidrBlock: 0.0.0.0/0
      Egress: 'true'
      Protocol: '-1'
      RuleAction: allow
      RuleNumber: '100'
      NetworkAclId: !Ref 'NetworkACL'

  InternetGatewayAttachment:
    Type: AWS::EC2::VPCGatewayAttachment
    Properties:
      VpcId: !Ref 'DemoVPC'
      InternetGatewayId: !Ref 'InternetGateway'

  publicroute:
    Type: AWS::EC2::Route
    Properties:
      DestinationCidrBlock: 0.0.0.0/0
      RouteTableId: !Ref 'RoutePrivate'
      GatewayId: !Ref 'InternetGateway'
    DependsOn: InternetGateway

  RoutePrivate:
    Type: AWS::EC2::RouteTable
    Properties:
      VpcId: !Ref 'DemoVPC'
      #TwitterTable:
    #Type: AWS::DynamoDB::Table
    #Properties:
      #TableName: Tweets
      #BillingMode: "PAY_PER_REQUEST"
      #KeySchema:
        #-
          #AttributeName: "tweet_id"
          #KeyType: "HASH"
      #AttributeDefinitions:
        #-
          #AttributeName: "tweet_id"
          #AttributeType: "N"
      #ProvisionedThroughput:
        #ReadCapacityUnits: "0"
        #WriteCapacityUnits: "0"

  MSKSecurityGroup:
    Type: 'AWS::EC2::SecurityGroup'
    Properties:
      GroupDescription: MSK Security Group
      SecurityGroupIngress:
        - Description: ZooKeeper Plaintext
          FromPort: 2181
          IpProtocol: tcp
#          SourceSecurityGroupId: DemoVPC-KafkaClientEC2InstanceSecurityGroupId
          ToPort: 2181
        - Description: Bootstrap servers Plaintext
          FromPort: 9092
          IpProtocol: tcp
#          SourceSecurityGroupId: DemoVPC-KafkaClientEC2InstanceSecurityGroupId
          ToPort: 9092
        - Description: Bootstrap servers TLS
          FromPort: 9094
          IpProtocol: tcp
#          SourceSecurityGroupId: DemoVPC-KafkaClientEC2InstanceSecurityGroupId
          ToPort: 9094
      VpcId: !Ref DemoVPC

  MSKSecurityGroup9092:
    Type: 'AWS::EC2::SecurityGroupIngress'
    Properties:
      IpProtocol: tcp
      Description: Enable access to port 9092 inside the MSKSecurityGroup
      FromPort: 9092
      GroupId: !GetAtt
        - MSKSecurityGroup
        - GroupId
      SourceSecurityGroupId: !GetAtt
        - MSKSecurityGroup
        - GroupId
      ToPort: 9092

  MSKSecurityGroup9094:
    Type: 'AWS::EC2::SecurityGroupIngress'
    Properties:
      IpProtocol: tcp
      Description: Enable access to port 9094 inside the MSKSecurityGroup
      FromPort: 9094
      GroupId: !GetAtt
        - MSKSecurityGroup
        - GroupId
      SourceSecurityGroupId: !GetAtt
        - MSKSecurityGroup
        - GroupId
      ToPort: 9094

  MSKSecurityGroup443:
    Type: 'AWS::EC2::SecurityGroupEgress'
    Properties:
      IpProtocol: tcp
      Description: Enable access to port external https address
      FromPort: 443
      GroupId: !GetAtt
        - MSKSecurityGroup
        - GroupId
      CidrIp: 0.0.0.0/0
      ToPort: 443

  MSKClusterNoMTLS:
    Type: 'AWS::MSK::Cluster'
    Properties:
      BrokerNodeGroupInfo:
        ClientSubnets:
          - !Ref PrivateSubnetA
          - !Ref PrivateSubnetB
          - !Ref PrivateSubnetC
        InstanceType: kafka.t3.small
        #        InstanceType: kafka.m5.large
        SecurityGroups:
          - !GetAtt
            - MSKSecurityGroup
            - GroupId
        StorageInfo:
          EBSStorageInfo:
            VolumeSize: 100
      ClusterName: !Join
        - ''
        - - MSKCluster-
          - !Ref 'AWS::StackName'
      KafkaVersion: 2.8.1
      NumberOfBrokerNodes: 3
      EncryptionInfo:
        EncryptionInTransit:
          ClientBroker: TLS_PLAINTEXT
          InCluster: true
      EnhancedMonitoring: DEFAULT
